<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Mark Madere (cciweb@acorn.org)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Membership Form' for the 'acorn_member' extension.
 *
 * @author	Mark Madere <cciweb@acorn.org>
 */


require_once(PATH_tslib."class.tslib_pibase.php");
require_once(PATH_tslib."class.tslib_fe.php");

class tx_acornmember_pi1 extends tslib_pibase {
	var $prefixId = "tx_acornmember_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_acornmember_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "acorn_member";	// The extension key.
	var $element = array();  // used to store various elements of the final form
	var $flexform_ds_LL = array(); // used to store address LL files
	var $error = 0;
	var $requiredSymbolWrap = array();
	var $money = false;
	var $email = array();

	/**
	 * [Put your description here]
	 */
	function headerWrap($header) {
		return '<div class=subhead>'.$header.'</div>';
	}
	/**
	 * [Put your description here]
	 */
	function main($content,$conf)	{ 
		# capture piVars for data comparision
		if ($this->piVars['button'][1])  $_SESSION['tx_acornmember_pi1']['button'][1] = var_export($this->piVars,true);
		if ($this->piVars['button'][2])  $_SESSION['tx_acornmember_pi1']['button'][2] = var_export($this->piVars,true);

		# set flexform local language key
		$this->FFLLkey = "l".strtoupper($this->LLkey);
		if($this->FFLLkey == "lDEFAULT") $this->FFLLkey = "lDEF";

		# Initialize template file
		$this->templateFileContent = $this->cObj->cObjGetSingle($conf['templateFile'],$conf['templateFile.']);
        
		# collect starting point and recursive settings
		if (strstr($this->cObj->currentRecord,"tt_content"))	{
			$conf["pidList"] = $this->cObj->data["pages"];
			$conf["recursive"] = $this->cObj->data["recursive"];
		}
		# simplifiy piVars
		if(!isset($this->piVars["country"]) && intval(t3lib_div::_GP('c'))) $this->piVars["country"] = intval(t3lib_div::_GP('c'));
		if(!isset($this->piVars["office"]) && intval(t3lib_div::_GP('o'))) $this->piVars["office"] = intval(t3lib_div::_GP('o'));
		# set wrap
		$element["form"]["wrapL"] = '<form name="membershipform" action="'.$this->pi_getPageLink($GLOBALS["TSFE"]->id.'#anchor').'" method="post">';
		$element["form"]["wrapR"] = '</form>';
		# apply to template
		$substArray=array();
		$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###MEMBERSHIP_FORM###');

		# get array of country information
		$element["country"] = $this->countryLIST($content,$conf);
		# set default country if piVars[country] does not exist
		if (!isset($this->piVars["country"])) $this->piVars["country"]=$conf["defaultCountry"];

		# get Localized Country specific join message
		$substArray['###COUNTRY_JOIN_MESSAGE###'] = $this->getFFLLrelContent($element["country"][$this->piVars["country"]]["flexform"],"message");
		$substArray['###COUNTRY_OFFICE_SELECT_MSG###'] =  $this->headerWrap($this->pi_getLL("country_office_select_msg"));

		# build country / office selector
		$substArray['###SELECT_COUNTRY###'] = $this->countrySELECT($element["country"],$this->piVars["country"]);
		$substArray['###SELECT_OFFICE###'] =$this->officeSELECT();

		# build membership selector 
		$element["membership"] = $this->membershipLIST($this->piVars["country"]);
		$substArray['###MEMBERSHIP_SELECT###'] = '';
		if ($element["membership"]) $substArray['###MEMBERSHIP_SELECT###'] = $this->membershipSELECT($element["membership"]);
		$substArray['###MEMBERSHIP_SELECT_MSG###'] = '';
		if ($substArray['###MEMBERSHIP_SELECT###']) $substArray['###MEMBERSHIP_SELECT_MSG###'] =  $this->headerWrap($this->pi_getLL("membership_select_msg"));

		# build payment options
		$substArray['###PAYSCHEDULE_SELECT###'] =  $this->payscheduleSELECT($element["membership"]);
		$substArray['###PAYSCHEDULE_SELECT_MSG###'] = ''; 
		if ($substArray['###PAYSCHEDULE_SELECT###']) $substArray['###PAYSCHEDULE_SELECT_MSG###'] =  $this->headerWrap($this->pi_getLL("payschedule_select_msg"));

		# build dues options
		$substArray['###DUES_SELECT###'] = $this->duesSELECT($element["membership"]); 
		$substArray['###DUES_SELECT_MSG###'] = '';
		if ($substArray['###DUES_SELECT###']) $substArray['###DUES_SELECT_MSG###'] = $this->headerWrap($this->pi_getLL("dues_select_msg"));

		# get  donation options
		$element["donation"] = $this->donationLIST($this->piVars["country"]);
		$substArray['###DONATION_SELECT###'] = '';
		if ($element["donation"]) $substArray['###DONATION_SELECT###'] = $this->donationSELECT($element["donation"]); 
		$substArray['###DONATION_SELECT_MSG###'] = '';
		if ($substArray['###DONATION_SELECT###']) $substArray['###DONATION_SELECT_MSG###'] = $this->headerWrap($this->pi_getLL("donation_select_msg"));
		
		# display personal info form
		$this->requiredSymbolWrap = explode ( '|', $this->conf["requiredSymbolWrap"]); 

		$substArray['###PERSONAL_INFO###'] = '';
		$validate = false;
		if ($this->piVars['button']) $validate = true;
		$contactINFO['personal'] = $this->flexform_ds2html($element['country'][$this->piVars["country"]]["address_flexform"],'sCONTACT',$validate);
		$substArray['###PERSONAL_INFO###'] = $contactINFO['personal']['form'];
		if ($substArray['###PERSONAL_INFO###']) $substArray['###PERSONAL_INFO_MSG###'] = $this->headerWrap($this->pi_getLL("personal_info_msg"));
		$substArray['###PERSONAL_FOOTNOTE###'] = $requiredSymbolWrap[0].$this->conf["requiredSymbol"].$requiredSymbolWrap[1].' '.$this->pi_getLL("personal_footnote");
		

		# display payment options
		$substArray['###PAYMENT_OPTIONS###'] = ''; 
		$substArray['###PAYMENT_SELECT_MSG###'] = ''; 
		if ($this->money) {
			$substArray['###PAYMENT_OPTIONS###'] = $this->payoptionSELECT($element['country']); 
			if($substArray['###PAYMENT_OPTIONS###']) $substArray['###PAYMENT_SELECT_MSG###'] = $this->headerWrap($this->pi_getLL("payment_select_msg"));
		}
		# display billing info form
		$substArray['###SAME_AS_PERSONAL###'] = ''; 
		$substArray['###BILLING_INFO###'] = ''; 
		$substArray['###BILLING_INFO_MSG###'] = '';
		$substArray['###BILLING_FOOTNOTE###'] = '';
		if ($this->money) {
			$substArray['###SAME_AS_PERSONAL###'] = '<input type="checkbox" name="tx_acornmember_pi1[same_address]" value="1"';
			if ($this->piVars['same_address'] == 1) $substArray['###SAME_AS_PERSONAL###'] .= ' checked';
			$substArray['###SAME_AS_PERSONAL###'] .= '>'.$this->pi_getLL("same_as_personal");
			$validate = false;
			if ($this->piVars['button'] && !$this->piVars['same_address']) $validate = true;
			$contactINFO['billing'] = $this->flexform_ds2html($element['country'][$this->piVars["country"]]["address_flexform"],'sBILL', $validate);
			$substArray['###BILLING_INFO###'] = $contactINFO['billing']['form'];
			if ($substArray['###BILLING_INFO###']) $substArray['###BILLING_INFO_MSG###'] = $this->headerWrap($this->pi_getLL("billing_info_msg"));
			$substArray['###BILLING_FOOTNOTE###'] = $requiredSymbolWrap[0].$this->conf["requiredSymbol"].$requiredSymbolWrap[1].' '.$this->pi_getLL("billing_footnote");
		}
		# display button
		$substArray['###BUTTON_NAME###'] = $this->pi_getLL("submit_button_label"); 
		$substArray['###BELOW_BUTTON_MSG###'] = $this->pi_getLL("below_button_msg"); 
		$substArray['###BUTTON_NAME###'] = $this->pi_getLL("submit_button_label"); 

		# display error message
		$substArray['###ERROR_MSG###'] = ''; 
		if ($this->piVars['button'] && $this->error) $substArray['###ERROR_MSG###'] = '<span class="error">'.$this->pi_getLL("error_msg").'</span>'; 
		
		
		# display confirmation
		$substArray['###CONFIRMATION_MSG###'] = ''; 
		$substArray['###CHANGES_MSG###'] = '';
		$substArray['###CONFIRMATION###'] = ''; 
		if ($this->piVars['button'] && !$this->error) {
			$substArray['###CONFIRMATION###'] = $this->confirmationForm($element,$contactINFO); 
			$substArray['###CHANGES_MSG###'] = $this->pi_getLL("changes_msg");
			$substArray['###COUNTRY_JOIN_MESSAGE###'] = '';
		}
		# process total form
		$output = $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		if($this->piVars['button'][2] && !$this->error && $this->piVars['iagree']['terms']) {
			# mail headers
			$headers = "From: ".$this->conf['emailSenderName']."<".$this->conf['emailSenderAddress'].">\r\n";
			$headers .= "Return-Path: ".$this->conf['sendersName']."<".$this->conf['emailSenderAddress'].">";

			# compose external email
			$exEmail = $this->composeExEmail($contactINFO);
			$this->email['global']['##EXTERNAL_EMAIL##'] = $exEmail;
			# send external email
			mail($this->piVars['sCONTACT']['email'],$this->email['subject']['external'],$exEmail,$headers);
			# compose internal email
			$inEmail = $this->composeInEmail($contactINFO);
			# generate list of receipients
			if(trim($this->conf['administartorEmailAddress'])) $this->email['recip'] = $this->email['recip'].$this->conf['administartorEmailAddress'];
			# send internal email
			mail($this->email['recip'],$this->email['subject']['external'],$inEmail,$headers);
			# save data to file
			/*
			$file['newfile'][0]['data'] = "cache-".time();
			$file['newfile'][0]['target'] = "uploads";
			$file['editfile'][0]['data'] = $this->pi_wrapInBaseClass($output);
			$file['editfile'][0]['target'] = $file['newfile'][0]['target'].'/'.$file['newfile'][0]['data'];
			$this->fileProcessor = t3lib_div::makeInstance('t3lib_extFileFunctions');
			$this->fileProcessor->start($file);
			$this->fileProcessor->processData();
			*/
			mail($this->conf['administartorEmailAddress'],'FORM',$this->pi_wrapInBaseClass($output),$headers);
			
			# display thank you page
			$thankyou = "<p>".$this->getFFLLrelContent($element["country"][$this->piVars["country"]]["flexform"],"thankyoumessage")."</p>";
			$thankyou .= "<p>".$this->getFFLLrelContent($element['membership'][$this->piVars["memLevelid"]]["flexform"],"thankyoumessage")."</p>";
			return $thankyou;
		}
		return $this->pi_wrapInBaseClass($element["form"]["wrapL"].$output.$element["form"]["wrapR"]);
	}
	/**
	 * [Put your description here]
	 */
	function countryLIST($content,$conf)	{
		$this->conf=$conf;		// Setting the TypoScript passed to this function in $this->conf
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();		// Loading the LOCAL_LANG values
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$lConf = $this->conf["listView."];	// Local settings for the listView function
		
		if (!isset($this->piVars["sort"]))  $this->piVars["sort"]="name";  // country name field from tx_acornoffice_country.name
			// Initializing the query parameters:
		list($this->internal["orderBy"],$this->internal["descFlag"]) = explode(":",$this->piVars["sort"]);
		$this->internal["results_at_a_time"]=t3lib_div::intInRange($lConf["results_at_a_time"],0,1000,100);		// Number of results to show in a listing.
		$this->internal["maxPages"]=t3lib_div::intInRange($lConf["maxPages"],0,1000,2);;		// The maximum number of "pages" in the browse-box: "Page 1", "Page 2", etc.
		$this->internal["searchFieldList"]="country,name";
		$this->internal["orderByList"]="uid,country,name";
		
			// Get number of records:
		$res = $this->pi_exec_query("tx_acornoffice_country",1);
		list($this->internal["res_count"]) = $GLOBALS['TYPO3_DB']->sql_fetch_row($res);

			// Make listing query, pass query to SQL database:
		$res = $this->pi_exec_query("tx_acornoffice_country");
		$this->internal["currentTable"] = "tx_acornoffice_country";

		// Make list table rows
		while($this->internal['currentRow'] = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))      {
			# filter hidden countries
			if (!$this->getFieldContent("tx_acornmember_hide")) {
				$country[$this->getFieldContent("uid")]["uid"] = $this->getFieldContent("uid");
				$country[$this->getFieldContent("uid")]["name"] = $this->getFieldContent("name");
				$country[$this->getFieldContent("uid")]["flexform"] = $this->getFieldContent("tx_acornmember_flexform");
				$country[$this->getFieldContent("uid")]["payment"] = $this->getFieldContent("tx_acornmember_payment");
				$country[$this->getFieldContent("uid")]["memberlevel"] = $this->getFieldContent("tx_acornmember_memberlevel");
				$country[$this->getFieldContent("uid")]["donatelevel"] = $this->getFieldContent("tx_acornmember_donatelevel");
				$country[$this->getFieldContent("uid")]["payment"] = $this->getFieldContent("tx_acornmember_payment");
				$country[$this->getFieldContent("uid")]["address_flexform"] = $this->getFieldContent("tx_acornmember_address_flexform");
				$country[$this->getFieldContent("uid")]["confirm_email"] = $this->getFieldContent("tx_acornmember_confirm_email");
			}
		}
		unset($this->piVars["sort"]);
		return $country;
	}
	/**
	 * [Put your description here]
	 */
	function countrySELECT($country,$uid) {
		$substArray=array();
		$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_COUNTRY_OUTER_WRAP1###');
		$tmpCountry = $this->piVars["country"];
		$substArray['###COUNTRY_UID###'] = $this->piVars["country"];	
		$out = $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		if (is_array($country)) $countrykeys = array_keys($country);
		for($i=0; $i<count($countrykeys); $i++) {
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_COUNTRY_INNER_WRAP###');
			$substArray['###COUNTRY_VALUE###'] = $country[$countrykeys[$i]]["uid"];
			$substArray['###selected###'] = ""; 
			if($country[$countrykeys[$i]]["uid"] == $uid) {
				$substArray['###selected###'] = " selected";	
				$this->email['external']['###COUNTRY_EMAIL###'] = $this->getFFLLrelContent($country[$countrykeys[$i]]["flexform"],"email_external");
				$this->email['internal']['###COUNTRY_EMAIL###'] = $this->getFFLLrelContent($country[$countrykeys[$i]]["flexform"],"email_internal");
				$this->email['subject']['external'] = $this->getFFLLrelContent($country[$countrykeys[$i]]["flexform"],"email_external_subject");
				$this->email['subject']['internal'] = $this->getFFLLrelContent($country[$countrykeys[$i]]["flexform"],"email_internal_subject");
				if(trim($country[$countrykeys[$i]]["confirm_email"])) $this->email['recip'] .= $country[$countrykeys[$i]]["confirm_email"].',';
			}
			$substArray['###COUNTRY_NAME###'] = $country[$countrykeys[$i]]["name"];
			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		}
		$out .= $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_COUNTRY_OUTER_WRAP2###');
		// reset piVars["country"] to original value
		$this->piVars["country"] = $tmpCountry;
		return $out;
	}
	/**
	 * [Put your description here]
	 */
	function officeSELECT()	{
		$substArray=array();
		$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_OFFICE_OUTER_WRAP1###');
		$tmpOffice = $this->piVars["office"];
		$substArray['###OFFICE_UID###'] = $this->piVars["office"];
		$substArray['###CHOOSE_OFFICE_MSG###'] = $this->pi_getLL("choose_office_msg");

		$out = $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);

		$query = "SELECT tx_acornoffice_office.uid, tx_acornoffice_office.office, tx_acornoffice_office.tx_acornmember_confirm_email AS email, tx_acornoffice_state.state, tx_acornoffice_state.tx_acornmember_confirm_email
					FROM tx_acornoffice_office,tx_acornoffice_state
					WHERE tx_acornoffice_office.country = ".$this->piVars["country"]."
					AND tx_acornoffice_state.uid = tx_acornoffice_office.state
					AND tx_acornoffice_office.tx_acornmember_hide  = 0
					AND tx_acornoffice_office.hidden = 0
					AND tx_acornoffice_office.deleted = 0
					AND tx_acornoffice_state.hidden = 0
					AND tx_acornoffice_state.deleted = 0
					ORDER BY tx_acornoffice_state.state,tx_acornoffice_office.office
			 		";
		$officeRes = mysql(TYPO3_db,$query);
		while($officeRow=mysql_fetch_assoc($officeRes)) {
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_OFFICE_INNER_WRAP###');
			$substArray['###OFFICE_VALUE###'] = $officeRow["uid"];
			$substArray['###selected###'] = "";
			if ($tmpOffice == $officeRow["uid"]) {
				$substArray['###selected###'] = " selected";
				if(trim($officeRow["tx_acornmember_confirm_email"])) $this->email['recip'] .= $officeRow["tx_acornmember_confirm_email"].',';
				if(trim($officeRow["email"])) $this->email['recip'] .= $officeRow["email"].',';
			}	
			$substArray['###OFFICE_NAME###'] = $officeRow["state"].": ".$officeRow["office"];
			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
			$office2countryTEST[] = $officeRow["uid"];
		}
		$substArray=array();
		$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_OFFICE_OUTER_WRAP2###');
		$substArray['###OTHER_OFFICE_MSG###'] = $this->pi_getLL("other_office_msg");
		$substArray['###selected###'] = ""; if ($this->piVars["office"] == "Other") $substArray['###selected###'] = " selected";	
		$substArray['###SELECT_OFFICE_ERROR_MSG###'] = "";
		if($this->piVars['button'] && $this->piVars["office"] == "Error") {
			$substArray['###SELECT_OFFICE_ERROR_MSG###'] = '<span class="error">'.$this->pi_getLL("select_office_error_msg").'</span>';
			$this->error++;
		}
		$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		// reset piVars["office"] to original value
		$this->piVars["office"] = $tmpOffice;
		// this is important for not trying to display donations for an office not found in the list.
		if(!in_array($this->piVars["office"],$office2countryTEST)) unset($this->piVars["office"]);
		return $out;		
	}
	function membershipLIST($countryUID) {
		// first SQL statement gatheres membership levels for this country
		$query = "SELECT tx_acornmember_level.uid,
					tx_acornmember_level.flexform,
					tx_acornmember_level.currency,
					tx_acornmember_level.dues,
					tx_acornmember_level.dues_mo_sel,
					tx_acornmember_level.dues_ot_sel,
					tx_acornmember_level.confirm_email
				  FROM tx_acornmember_level,
				  	tx_acornoffice_country_tx_acornmember_memberlevel_mm
				  WHERE tx_acornoffice_country_tx_acornmember_memberlevel_mm.uid_local = $countryUID
				  	AND tx_acornoffice_country_tx_acornmember_memberlevel_mm.uid_foreign = tx_acornmember_level.uid
					AND tx_acornmember_level.hidden = 0
					AND tx_acornmember_level.deleted = 0
				  ORDER BY tx_acornoffice_country_tx_acornmember_memberlevel_mm.sorting
				  ";
		$membershipRes = mysql(TYPO3_db,$query);
		while($membershipRow=mysql_fetch_assoc($membershipRes)) {
			$membership[$membershipRow["uid"]] = $membershipRow;
			// second SQL statement gathers monthly dues levels for each membership level
			$moPayoptionquery = "SELECT tx_acornmember_payoption.uid,
							tx_acornmember_payoption.blank,
							tx_acornmember_payoption.amount,
							tx_acornmember_payoption.flexform
						  FROM tx_acornmember_level_dues_mo_mm, 
						  	tx_acornmember_payoption
						  WHERE tx_acornmember_level_dues_mo_mm.uid_local = ".$membership[$membershipRow["uid"]]["uid"]."
						    AND tx_acornmember_level_dues_mo_mm.uid_foreign = tx_acornmember_payoption.uid
							AND tx_acornmember_payoption.hidden = 0
							AND tx_acornmember_payoption.deleted = 0
						  ORDER BY tx_acornmember_level_dues_mo_mm.sorting
						  ";
			$moPayoptionRes = mysql(TYPO3_db,$moPayoptionquery);
			while($mopayoptionRow=mysql_fetch_assoc($moPayoptionRes)) {
				$membership[$membershipRow["uid"]]["payoption"]["mo"][$mopayoptionRow["uid"]] = $mopayoptionRow;
				if(!$membership[$membershipRow["uid"]]["mo_min"]) {
					$membership[$membershipRow["uid"]]["mo_min"]["uid"] = $mopayoptionRow["uid"];
					$membership[$membershipRow["uid"]]["mo_min"]["amount"] = $mopayoptionRow["amount"];
				} else if ($membership[$membershipRow["uid"]]["mo_min"]["amount"] > $mopayoptionRow["amount"]) {
					$membership[$membershipRow["uid"]]["mo_min"]["uid"] = $mopayoptionRow["uid"];
					$membership[$membershipRow["uid"]]["mo_min"]["amount"] = $mopayoptionRow["amount"];
				}
			}
			// second SQL statement gathers one time dues levels for each membership level
			$otPayoptionquery = "SELECT tx_acornmember_payoption.uid,
							tx_acornmember_payoption.blank,
							tx_acornmember_payoption.amount,
							tx_acornmember_payoption.flexform
						  FROM tx_acornmember_level_dues_ot_mm, 
						  	tx_acornmember_payoption
						  WHERE tx_acornmember_level_dues_ot_mm.uid_local = ".$membership[$membershipRow["uid"]]["uid"]."
						    AND tx_acornmember_level_dues_ot_mm.uid_foreign = tx_acornmember_payoption.uid
							AND tx_acornmember_payoption.hidden = 0
							AND tx_acornmember_payoption.deleted = 0
						  ORDER BY tx_acornmember_level_dues_ot_mm.sorting
						  ";
			$otPayoptionRes = mysql(TYPO3_db,$otPayoptionquery);
			while($otpayoptionRow=mysql_fetch_assoc($otPayoptionRes)) {
				$membership[$membershipRow["uid"]]["payoption"]["ot"][$otpayoptionRow["uid"]] = $otpayoptionRow;
			}
		}
		return $membership;
	}
	/**
	 * [Put your description here]
	 */
	function membershipSELECT($membership) {
		$out = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_MEMBERSHIP_OUTER_WRAP1###');
		if (is_array($membership)) $membershipkeys = array_keys($membership);
		for($i=0; $i<count($membershipkeys); $i++) {
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_MEMBERSHIP_INNER_WRAP###');
			$substArray['###MEMBERSHIP_VALUE###'] = $membership[$membershipkeys[$i]]["uid"];
			$substArray['###checked###'] = '';
			if(!$this->piVars["memLevelid"]  || ($this->piVars["memLevelid"] && !array_key_exists($this->piVars["memLevelid"],$membership)) ) {
				$this->piVars["memLevelid"] = $membership[$membershipkeys[$i]]["uid"];
			}
			$substArray['###MEMBERSHIP_LEVEL###'] = $this->getFFLLrelContent($membership[$membershipkeys[$i]]["flexform"],"levelname");
			$substArray['###CURRENCY_SYMBOL###'] = $membership[$membershipkeys[$i]]["currency"];
			$substArray['###ANNUAL_DUES###'] = $membership[$membershipkeys[$i]]["dues"];
			if($membership[$membershipkeys[$i]]["uid"] == $this->piVars["memLevelid"]) {
				$substArray['###checked###'] = ' checked';
				$this->email['global']['##MEMBER_TITLE##'] = $this->getFFLLrelContent($membership[$membershipkeys[$i]]["flexform"],"leveltitle");
				$this->email['external']['##MEMBER_EMAIL##'] = $this->getFFLLrelContent($membership[$membershipkeys[$i]]["flexform"],"email_external");
				$this->email['internal']['##MEMBER_EMAIL##'] = $this->getFFLLrelContent($membership[$membershipkeys[$i]]["flexform"],"email_internal");
				if(trim($membership[$membershipkeys[$i]]["confirm_email"])) $this->email['recip'] .= $membership[$membershipkeys[$i]]["confirm_email"].',';
				# check for money
				if ($substArray['###ANNUAL_DUES###']) $this->money = true;
			}
			if ($substArray['###ANNUAL_DUES###'] == 0) $substArray['###ANNUAL_DUES###'] = "0";
			$substArray['###ANNUAL_DUES###']  .= '  '.$this->pi_getLL("annual_per_year_msg");
			$substArray['###MONTHLY_CURRENCY_SYMBOL###'] = '';
			$substArray['###MONTHLY_MIN###'] = '';
			if($membership[$membershipkeys[$i]]["mo_min"]) {
				$substArray['###MONTHLY_CURRENCY_SYMBOL###'] = '('.$membership[$membershipkeys[$i]]["currency"];
				$substArray['###MONTHLY_MIN###'] = $membership[$membershipkeys[$i]]["mo_min"]["amount"].' '.$this->pi_getLL("minimum_per_month_msg").')';
			}
			$substArray['###BRIEF_MEMBERSHIP_DESCRIPTION###'] = $this->getFFLLrelContent($membership[$membershipkeys[$i]]["flexform"],"teasertext");


			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		}
		$out .= $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_MEMBERSHIP_OUTER_WRAP2###');
		return $out;
	}

	function payscheduleSELECT($membership) {
		if($membership[$this->piVars["memLevelid"]]["payoption"]["mo"]) {
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_PAYSCHEDULE###');

			$substArray['###MEMBERSHIP_VALUE###'] = $membership[$this->piVars["memLevelid"]]["uid"];
			$substArray['###PAYSCHEDULE_VALUE###'] = 'MO';
			$substArray['###PAYSCHEDULE_NAME###'] = $this->pi_getLL("payschedule_monthly");
			$substArray['###checked###'] = '';
			if(!$this->piVars["duesPaySchedule"]) $this->piVars["duesPaySchedule"] = 'MO';
			if($this->piVars["duesPaySchedule"] == 'MO') {
				$substArray['###checked###'] = ' checked';
				$this->email['global']['##DUES_SCHEDULE##'] = strtolower($this->pi_getLL("payschedule_monthly"));
			}
			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		}
		if($membership[$this->piVars["memLevelid"]]["payoption"]["ot"]) {
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_PAYSCHEDULE###');
			$substArray['###MEMBERSHIP_VALUE###'] = $membership[$this->piVars["memLevelid"]]["uid"];
			$substArray['###PAYSCHEDULE_VALUE###'] = 'OT';
			$substArray['###PAYSCHEDULE_NAME###'] = $this->pi_getLL("payschedule_onetime");
			$substArray['###checked###'] = '';
			if(!$this->piVars["duesPaySchedule"]) $this->piVars["duesPaySchedule"] = 'OT';
			if($this->piVars["duesPaySchedule"] == 'OT') {
				$substArray['###checked###'] = ' checked';
				$this->email['global']['##DUES_SCHEDULE##'] = strtolower($this->pi_getLL("payschedule_onetime"));
			}
			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		}
		return $out;
	}
	function duesSELECT($membership) {
		if (is_array($membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])])) $dueskeys = array_keys($membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])]);
		for($i=0; $i<count($dueskeys); $i++) {		
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_DUES###');
			$substArray['###DUES_ERROR_MSG###'] = '';
			$substArray['###MEMBERSHIP_VALUE###'] = $membership[$this->piVars["memLevelid"]]["uid"];
			$substArray['###DUES_VALUE###'] = $membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["uid"];
			$substArray['###CURRENCY_SYMBOL###'] = $membership[$this->piVars["memLevelid"]]["currency"];
			$substArray['###DUES_AMOUNT###'] = $membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["amount"];
			if ($membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["blank"]) {
				$substArray['###DUES_AMOUNT###'] = '<input type="text" size="4" name="tx_acornmember_pi1[duesPayOption][other]['.$membership[$this->piVars["memLevelid"]]["uid"].']['.$dueskeys[$i].']"';
				if($this->piVars['duesPayOption']['other'][$membership[$this->piVars["memLevelid"]]["uid"]][$dueskeys[$i]]) {
					$substArray['###DUES_AMOUNT###'] .= 'value="'.$this->piVars['duesPayOption']['other'][$membership[$this->piVars["memLevelid"]]["uid"]][$dueskeys[$i]].'"';
					if ( ($this->piVars["duesPayOption"][$membership[$this->piVars["memLevelid"]]["uid"]] == $membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["uid"]) && ($this->piVars['duesPayOption']['other'][$membership[$this->piVars["memLevelid"]]["uid"]][$dueskeys[$i]] < $membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["amount"]) ) {
						$this->error++;
						$substArray['###DUES_ERROR_MSG###'] = '<span class="error">'.$this->pi_getLL("dues_error_msg_2").' '.$membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["amount"].'</span>';
					}
				} else {
					$substArray['###DUES_AMOUNT###'] .= 'value="'.$membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["amount"].'"';
				}
				$substArray['###DUES_AMOUNT###'] .= ">";
			}
			$substArray['###DUES_LABEL###'] = $this->getFFLLrelContent($membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["flexform"],"label");
			$substArray['###checked###'] = '';
			$dues_sel = "dues_".strtolower($this->piVars["duesPaySchedule"])."_sel";
			if ( (!$this->piVars["duesPayOption"][$membership[$this->piVars["memLevelid"]]["uid"]] && $membership[$this->piVars["memLevelid"]][$dues_sel] == ($i+1)) || ($this->piVars["duesPayOption"][$membership[$this->piVars["memLevelid"]]["uid"]] && !array_key_exists($this->piVars["duesPayOption"][$membership[$this->piVars["memLevelid"]]["uid"]],$membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])]) && $membership[$this->piVars["memLevelid"]][$dues_sel] == ($i+1)) ) {
				$this->piVars["duesPayOption"][$membership[$this->piVars["memLevelid"]]["uid"]] = $membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["uid"];
			}
			if ($this->piVars["duesPayOption"][$membership[$this->piVars["memLevelid"]]["uid"]] == $membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["uid"]) {
				$substArray['###checked###'] = ' checked';
				$this->email['global']['##DUES_CURRENCY##'] = $membership[$this->piVars["memLevelid"]]["currency"];			
				if ($membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["blank"]) {
					$this->email['global']['##DUES_AMOUNT##'] = $this->piVars['duesPayOption']['other'][$membership[$this->piVars["memLevelid"]]["uid"]][$dueskeys[$i]];
				} else {
					$this->email['global']['##DUES_AMOUNT##'] = $membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["amount"];
					# $this->email['global']['##DUES_SCHEDULE##'] = $this->getFFLLrelContent($membership[$this->piVars["memLevelid"]]["payoption"][strtolower($this->piVars["duesPaySchedule"])][$dueskeys[$i]]["flexform"],"label");
				}			
			}
			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		}
		return $out;
	}
	function donationLIST($countryUID) {
		// PART A first SQL statement gatheres donation levels for this country
		$query = "SELECT tx_acornmember_donate.uid,
					tx_acornmember_donate.flexform,
					tx_acornmember_donate.url,
					tx_acornmember_donate.currency,
					tx_acornmember_donate.donation_mo_sel,
					tx_acornmember_donate.donation_ot_sel,
					tx_acornmember_donate.confirm_email
				  FROM tx_acornmember_donate,
				  	tx_acornoffice_country_tx_acornmember_donatelevel_mm
				  WHERE tx_acornoffice_country_tx_acornmember_donatelevel_mm.uid_local = $countryUID
				  	AND tx_acornoffice_country_tx_acornmember_donatelevel_mm.uid_foreign = tx_acornmember_donate.uid
					AND tx_acornmember_donate.hidden = 0
					AND tx_acornmember_donate.deleted = 0
				  ORDER BY tx_acornoffice_country_tx_acornmember_donatelevel_mm.sorting
				  ";
		$donationRes = mysql(TYPO3_db,$query);
		while($donationRow=mysql_fetch_assoc($donationRes)) {
			$donation[$donationRow["uid"]] = $donationRow;
		}
		// PART B first SQL statement gatheres donation levels for this office if an office is selected
		if($this->piVars["office"]) {
			$query = "SELECT tx_acornmember_donate.uid,
						tx_acornmember_donate.flexform,
						tx_acornmember_donate.url,
						tx_acornmember_donate.currency,
						tx_acornmember_donate.donation_mo_sel,
						tx_acornmember_donate.donation_ot_sel,
						tx_acornmember_donate.confirm_email
					  FROM tx_acornmember_donate,
						tx_acornoffice_office_tx_acornmember_donate_mm
					  WHERE tx_acornoffice_office_tx_acornmember_donate_mm.uid_local = ".$this->piVars["office"]."
						AND tx_acornoffice_office_tx_acornmember_donate_mm.uid_foreign = tx_acornmember_donate.uid
						AND tx_acornmember_donate.hidden = 0
						AND tx_acornmember_donate.deleted = 0
					  ORDER BY tx_acornoffice_office_tx_acornmember_donate_mm.sorting
					  ";
			$donationRes = mysql(TYPO3_db,$query);
			while($donationRow=mysql_fetch_assoc($donationRes)) {
				$donation[$donationRow["uid"]] = $donationRow;
			}
		}
		if (is_array($donation)) $donationkeys = array_keys($donation);
		for($i=0; $i<count($donationkeys); $i++) {
		
			// second SQL statement gathers monthly dues levels for each donation level
			$moPayoptionquery = "SELECT tx_acornmember_payoption.uid,
							tx_acornmember_payoption.blank,
							tx_acornmember_payoption.amount,
							tx_acornmember_payoption.flexform
						  FROM tx_acornmember_donate_donation_mo_mm, 
						  	tx_acornmember_payoption
						  WHERE tx_acornmember_donate_donation_mo_mm.uid_local = ".$donation[$donationkeys[$i]]["uid"]."
						    AND tx_acornmember_donate_donation_mo_mm.uid_foreign = tx_acornmember_payoption.uid
							AND tx_acornmember_payoption.hidden = 0
							AND tx_acornmember_payoption.deleted = 0
						  ORDER BY tx_acornmember_donate_donation_mo_mm.sorting
						  ";
			$moPayoptionRes = mysql(TYPO3_db,$moPayoptionquery);
			while($mopayoptionRow=mysql_fetch_assoc($moPayoptionRes)) {
				$donation[$donationkeys[$i]]["payoption"]["mo"][$mopayoptionRow["uid"]] = $mopayoptionRow;
			}
			// second SQL statement gathers one time dues levels for each donation level
			$otPayoptionquery = "SELECT tx_acornmember_payoption.uid,
							tx_acornmember_payoption.blank,
							tx_acornmember_payoption.amount,
							tx_acornmember_payoption.flexform
						  FROM tx_acornmember_donate_donation_ot_mm, 
						  	tx_acornmember_payoption
						  WHERE tx_acornmember_donate_donation_ot_mm.uid_local = ".$donation[$donationkeys[$i]]["uid"]."
						    AND tx_acornmember_donate_donation_ot_mm.uid_foreign = tx_acornmember_payoption.uid
							AND tx_acornmember_payoption.hidden = 0
							AND tx_acornmember_payoption.deleted = 0
						  ORDER BY tx_acornmember_donate_donation_ot_mm.sorting
						  ";
			$otPayoptionRes = mysql(TYPO3_db,$otPayoptionquery);
			while($otpayoptionRow=mysql_fetch_assoc($otPayoptionRes)) {
				$donation[$donationkeys[$i]]["payoption"]["ot"][$otpayoptionRow["uid"]] = $otpayoptionRow;
			}
		}
		return $donation;
	}

	/**
	 * [Put your description here]
	 */
	function donationSELECT($donation) {
		$out = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_DONATION_OUTER_WRAP1###');
		if (is_array($donation)) $donationkeys = array_keys($donation);
		for($i=0; $i<count($donationkeys); $i++) {
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_DONATION_INNER_WRAP1###');
			$substArray['###DONATION_VALUE###'] = $donation[$donationkeys[$i]]["uid"];
			$substArray['###checked###'] = '';
			if($donation[$donationkeys[$i]]["uid"] == $this->piVars["donation"][ $donation[$donationkeys[$i]]["uid"] ]["uid"]) {
				$validate[$i] = 1;
				$substArray['###checked###'] = ' checked';
				$this->money = true;
			}
			$substArray['###DONATION_LEVEL###'] = $this->getFFLLrelContent($donation[$donationkeys[$i]]["flexform"],"org");
			$substArray['###BRIEF_DONATION_DESCRIPTION###'] = $this->getFFLLrelContent($donation[$donationkeys[$i]]["flexform"],"teasertext");
			$substArray['###MONTHLY_DONATION_OPTIONS###'] = $this->donationOptionSELECT($donation[$donationkeys[$i]]["payoption"]["mo"],$donation[$donationkeys[$i]]["currency"],$donation[$donationkeys[$i]]["uid"],$donation[$donationkeys[$i]]["donation_mo_sel"],$validate[$i]);
			$substArray['###ONETIME_DONATION_OPTIONS###'] = $this->donationOptionSELECT($donation[$donationkeys[$i]]["payoption"]["ot"],$donation[$donationkeys[$i]]["currency"],$donation[$donationkeys[$i]]["uid"],$donation[$donationkeys[$i]]["donation_ot_sel"],$validate[$i]);
			$substArray['###OR_MSG###'] = '';
			if ($substArray['###MONTHLY_DONATION_OPTIONS###'] && $substArray['###ONETIME_DONATION_OPTIONS###']) $substArray['###OR_MSG###'] = '<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$this->pi_getLL("donation_or_msg").' <br>';
			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		}
		$out .= $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_DONATION_OUTER_WRAP2###');
		return $out;
	}

	function donationOptionSELECT($options,$currency,$donationID,$selectedItem,$validate=0) {
		if(is_array($options)) $donationkeys = array_keys($options);
		for($i=0; $i<count($donationkeys); $i++) {		
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_DONATION###');
			$substArray['###DONATION_VALUE###'] = $donationID;
			$substArray['###DONATION_OPTION_VALUE###'] = $options[$donationkeys[$i]]["uid"];
			$substArray['###checked###'] = '';
			$substArray['###DONATION_ERROR_MSG###'] = '';
			if (!$this->piVars["donation"][$donationID]["option"] && $selectedItem == $i+1) $this->piVars["donation"][$donationID]["option"] = $options[$donationkeys[$i]]["uid"];
			if ($this->piVars["donation"][$donationID]["option"] == $options[$donationkeys[$i]]["uid"]) $substArray['###checked###'] = ' checked';

			$substArray['###CURRENCY_SYMBOL###'] = $currency; 
			$substArray['###DONATION_AMOUNT###'] = $options[$donationkeys[$i]]["amount"]; 

			if ($options[$donationkeys[$i]]["blank"]) {
				$substArray['###DONATION_AMOUNT###'] = '<input type="text" size="4" name="tx_acornmember_pi1[donation][other]['.$donationID.']['.$options[$donationkeys[$i]]["uid"].']"';
				if($this->piVars['donation']['other'][$donationID][$options[$donationkeys[$i]]["uid"]]) {
					$substArray['###DONATION_AMOUNT###'] .= 'value="'.$this->piVars['donation']['other'][$donationID][$options[$donationkeys[$i]]["uid"]].'"';
				} else {
					$substArray['###DONATION_AMOUNT###'] .= 'value="'.$options[$donationkeys[$i]]["amount"].'"';
				}
				$substArray['###DONATION_AMOUNT###'] .= ">";
				if (	$validate && $this->piVars["donation"][$donationID]["option"] == $options[$donationkeys[$i]]["uid"] && $this->piVars['donation']['other'][$donationID][$options[$donationkeys[$i]]["uid"]] < $options[$donationkeys[$i]]["amount"]) {	
						$this->error++;
						$substArray['###DONATION_ERROR_MSG###'] = '<span class="error">'.$this->pi_getLL("donation_error_msg_2").' '.$options[$donationkeys[$i]]["amount"].'</span>';
				}
			}

			$substArray['###DONATION_LABEL###'] = $this->getFFLLrelContent($options[$donationkeys[$i]]["flexform"],"label");
			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		}
		return $out;
	}
	/**
	 * [Put your description here]
	 */
	function payoptionSELECT($country) {
		# get list of payment options for this country
		$payment = explode ( ',', $country[$this->piVars['country']]['payment']);
		$substArray=array();
		$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_PAYOPTION_OUTER_WRAP1###');
		$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		for($i=0; $i<count($payment); $i++) {
			switch($payment[$i]) {
				case "CC":
						$substArray=array();
						$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_PAYOPTION_CC###');
						$substArray['###checked###'] = '';
						if(!$this->piVars['payoption']['type']) $this->piVars['payoption']['type'] = $payment[$i];
						if($this->piVars['payoption']['type'] ==  $payment[$i]) $substArray['###checked###'] = "checked";
						$substArray['###CLASS_NAME###'] = "table-row".($i%2 ? 2 : 1);
						$substArray['###PAYMENT_TYPE###'] = $payment[$i];
						$substArray['###PAYMENT_LABEL###'] = $this->pi_getLL("CC_label");
						
						$substArray['###CARDNUM_MSG###'] = $this->pi_getLL("creditcard_cardnum");
						if($this->piVars['payoption']['type'] ==  $payment[$i] && $this->piVars['button'] && !trim($this->piVars['payoption']['CC']['number'])) {
							$substArray['###CARDNUM_MSG###'] = '<span class="error">'.$substArray['###CARDNUM_MSG###'].'</span>';
							$this->error++;
						}						
						$substArray['###CC_NUMBER_VALUE###'] = ''; 
						if($this->piVars['payoption']['CC']['number']) $substArray['###CC_NUMBER_VALUE###'] = ' value="'.$this->piVars['payoption']['CC']['number'].'"';
						$substArray['###EXPDATE_MSG###'] = $this->pi_getLL("creditcard_expdate");
						if($this->piVars['payoption']['type'] ==  $payment[$i] && $this->piVars['button'] && !trim($this->piVars['payoption']['CC']['expdate'])) {
							$substArray['###EXPDATE_MSG###'] = '<span class="error">'.$substArray['###EXPDATE_MSG###'].'</span>';
							$this->error++;
						}
						$substArray['###CC_EXPDATE_VALUE###'] = ''; 
						if($this->piVars['payoption']['CC']['expdate']) $substArray['###CC_EXPDATE_VALUE###'] = ' value="'.$this->piVars['payoption']['CC']['expdate'].'"';
						$substArray['###CARD_TYPES###'] = $this->payoptionCARDTYPE();
						$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
					break;			
				default:
						$substArray=array();
						$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_PAYOPTION_DEFAULT###');
						$substArray['###checked###'] = '';
						if(!$this->piVars['payoption']['type']) $this->piVars['payoption']['type'] = $payment[$i];
						if($this->piVars['payoption']['type'] ==  $payment[$i]) $substArray['###checked###'] = "checked";
						$substArray['###CLASS_NAME###'] = "table-row".($i%2 ? 2 : 1);
						$substArray['###PAYMENT_TYPE###'] = $payment[$i];
						$substArray['###PAYMENT_LABEL###'] = $this->pi_getLL($payment[$i]."_label");
						# get country specific label if exist
						# ex: CA_label.2
						if ($this->pi_getLL($payment[$i]."_label.".$this->piVars['country'])) $substArray['###PAYMENT_LABEL###'] = $this->pi_getLL($payment[$i]."_label.".$this->piVars['country']);

						$substArray['###ROUTENUM_MSG###'] = $this->pi_getLL("bank_routing_number");
						if($this->piVars['payoption']['type'] ==  $payment[$i] && $this->piVars['button'] && !trim($this->piVars['payoption'][$payment[$i]]['routing'])) {
							$substArray['###ROUTENUM_MSG###'] = '<span class="error">'.$substArray['###ROUTENUM_MSG###'].'</span>';
							$this->error++;
						}
						$substArray['###ROUTE_NUMBER_VALUE###'] = ''; 
						if($this->piVars['payoption'][$payment[$i]]['routing']) $substArray['###ROUTE_NUMBER_VALUE###'] = ' value="'.$this->piVars['payoption'][$payment[$i]]['routing'].'"';
						$substArray['###ACCTNUM_MSG###'] = $this->pi_getLL("bank_account_number");
						if($this->piVars['payoption']['type'] ==  $payment[$i] && $this->piVars['button'] && !trim($this->piVars['payoption'][$payment[$i]]['account'])) {
							$substArray['###ACCTNUM_MSG###'] = '<span class="error">'.$substArray['###ACCTNUM_MSG###'].'</span>';
							$this->error++;
						}
						$substArray['###ACCT_NUMBER_VALUE###'] = ''; 
						if($this->piVars['payoption'][$payment[$i]]['account']) $substArray['###ACCT_NUMBER_VALUE###'] = ' value="'.$this->piVars['payoption'][$payment[$i]]['account'].'"';
						$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
					break;			
			}
		}
		$substArray=array();
		$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_PAYOPTION_OUTER_WRAP2###');
		$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		return $out;
	}
	/**
	 * [Put your description here]
	 */
	function payoptionCARDTYPE() {
		$card = explode ( ',', $this->conf["cardtypes"]);
		for ($j=0; $j<count($card); $j++) {
			$substArray=array();
			$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###EL_SELECT_CARD###');
			$substArray['###PAYMENT_TYPE###'] = 'CC'; 
			$substArray['###CARDTYPE_VALUE###'] = $card[$j]; 
			$substArray['###checked###'] = '';
			if(!$this->piVars['payoption']['CC']['cardtype'])  $this->piVars['payoption']['CC']['cardtype'] = $card[$j];
			if($this->piVars['payoption']['CC']['cardtype'] ==  $card[$j]) $substArray['###checked###'] = "checked";
			$substArray['###CARD_LABEL###'] = $card[$j]; 

			$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		}
		return $out;
	}
	/**
	 * [Put your description here]
	 */
	function confirmationForm($element,$contactINFO) {
		$substArray=array();
		$dataRowContent = $this->cObj->getSubpart($this->templateFileContent,'###CONFIRMATION_FORM###');
		$substArray['###CONFIRMATION_MSG###'] = $this->headerWrap($this->pi_getLL("confirmation_msg"));
		$substArray['###VERIFY_MSG###'] = $this->getFFLLrelContent($element["country"][$this->piVars["country"]]["flexform"],"confirmationmessage"); 
		$substArray['###VERIFY_ADDRESS_MSG###'] = $this->pi_getLL("verify_address_msg"); 
		$substArray['###PERSONAL_INFO_HEAD###'] = $this->pi_getLL("personal_info_header"); 
		$substArray['###PERSONAL_INFO###'] = $contactINFO['personal']['plain']; 
		$substArray['###BILLING_INFO_HEAD###'] = $this->pi_getLL("billing_info_header"); 
		$substArray['###BILLING_INFO###'] = $contactINFO['billing']['plain']; 
		if($this->piVars['same_address']) $substArray['###BILLING_INFO###'] = $this->pi_getLL("same_as_personal");		
		$substArray['###VERIFY_MEMBERSHIP_MSG###'] = $this->pi_getLL("verify_membership_msg"); 
		$substArray['###MEMBERSHIP_LEVEL###'] = $this->getFFLLrelContent($element['membership'][$this->piVars["memLevelid"]]["flexform"],"levelname"); 
		$substArray['###MEMBERSHIP_DUES###'] = $this->membershipDues($element);
		$substArray['###VERIFY_DONATIONS_MSG###'] = '';
		$substArray['###DONATIONS###'] = '';

		if(is_array($this->piVars['donation'])) $donationkeys = array_keys($this->piVars['donation']);
		$j=0;
		for($i=0; $i <count($donationkeys); $i++) {
			if($this->piVars['donation'][$donationkeys[$i]]['uid']) {
				$substArray['###DONATIONS###'] .= '<div><strong>'.$this->getFFLLrelContent($element['donation'][$donationkeys[$i]]["flexform"],"org").'</strong> - '; 
				$substArray['###DONATIONS###'] .= $element['donation'][$donationkeys[$i]]["currency"];
				$this->email['donation'][$j]['external']['##DONATION_EMAIL##'] = $this->getFFLLrelContent($element['donation'][$donationkeys[$i]]["flexform"],"email_external");
				$this->email['donation'][$j]['internal']['##DONATION_EMAIL##'] = $this->getFFLLrelContent($element['donation'][$donationkeys[$i]]["flexform"],"email_internal");
				$this->email['donation'][$j]['global']['##DONATION_CURRENCY##'] = $element['donation'][$donationkeys[$i]]["currency"];
				if(trim($element['donation'][$donationkeys[$i]]["confirm_email"])) $this->email['recip'] .= $element['donation'][$donationkeys[$i]]["confirm_email"].',';
				
				
				# check for write in
				if($element['donation'][$donationkeys[$i]]["payoption"]["mo"][$this->piVars['donation'][$donationkeys[$i]]['option']]["amount"]) {
					$this->email['donation'][$j]['global']['##DONATION_SCHEDULE##'] = strtolower($this->pi_getLL("payschedule_monthly"));
					if($element['donation'][$donationkeys[$i]]["payoption"]["mo"][$this->piVars['donation'][$donationkeys[$i]]['option']]["blank"]) {
						$substArray['###DONATIONS###'] .= $this->piVars['donation']['other'] [$donationkeys[$i]] [$this->piVars['donation'][$donationkeys[$i]]['option']].' '.$this->pi_getLL("payschedule_monthly");
						#$this->email['donation'][$j]['global']['##DONATION_SCHEDULE##'] = strtolower($this->pi_getLL("payschedule_monthly"));
						$this->email['donation'][$j]['global']['##DONATION_AMOUNT##'] = $this->piVars['donation']['other'][$donationkeys[$i]][$this->piVars['donation'][$donationkeys[$i]]['option']];
					} else {
						$substArray['###DONATIONS###'] .= $element['donation'][$donationkeys[$i]]["payoption"]["mo"][$this->piVars['donation'][$donationkeys[$i]]['option']]["amount"];
						$substArray['###DONATIONS###'] .= ' '.$this->getFFLLrelContent($element['donation'][$donationkeys[$i]]["payoption"]["mo"][$this->piVars['donation'][$donationkeys[$i]]['option']]["flexform"],"label");
						#$this->email['donation'][$j]['global']['##DONATION_SCHEDULE##'] = $this->getFFLLrelContent($element['donation'][$donationkeys[$i]]["payoption"]["mo"][$this->piVars['donation'][$donationkeys[$i]]['option']]["flexform"],"label");
						$this->email['donation'][$j]['global']['##DONATION_AMOUNT##'] = $element['donation'][$donationkeys[$i]]["payoption"]["mo"][$this->piVars['donation'][$donationkeys[$i]]['option']]["amount"];
					}
					$j++;
				}
				if($element['donation'][$donationkeys[$i]]["payoption"]["ot"][$this->piVars['donation'][$donationkeys[$i]]['option']]["amount"]) {
					$this->email['donation'][$j]['global']['##DONATION_SCHEDULE##'] = strtolower($this->pi_getLL("payschedule_onetime"));
					if($element['donation'][$donationkeys[$i]]["payoption"]["ot"] [$this->piVars['donation'][$donationkeys[$i]] ['option']]["blank"]) {
						$substArray['###DONATIONS###'] .= $this->piVars['donation']['other'][$donationkeys[$i]][$this->piVars['donation'][$donationkeys[$i]]['option']].' '.$this->pi_getLL("payschedule_onetime");
						#$this->email['donation'][$j]['global']['##DONATION_SCHEDULE##'] = strtolower($this->pi_getLL("payschedule_onetime"));
						$this->email['donation'][$j]['global']['##DONATION_AMOUNT##'] = $this->piVars['donation']['other'][$donationkeys[$i]][$this->piVars['donation'][$donationkeys[$i]]['option']];
					} else {
						$substArray['###DONATIONS###'] .= $element['donation'][$donationkeys[$i]]["payoption"]["ot"][$this->piVars['donation'][$donationkeys[$i]]['option']]["amount"];
						$substArray['###DONATIONS###'] .= ' '.$this->getFFLLrelContent($element['donation'][$donationkeys[$i]]["payoption"]["ot"][$this->piVars['donation'][$donationkeys[$i]]['option']]["flexform"],"label");
						#$this->email['donation'][$j]['global']['##DONATION_SCHEDULE##'] = $this->getFFLLrelContent($element['donation'][$donationkeys[$i]]["payoption"]["ot"][$this->piVars['donation'][$donationkeys[$i]]['option']]["flexform"],"label");
						$this->email['donation'][$j]['global']['##DONATION_AMOUNT##'] = $element['donation'][$donationkeys[$i]]["payoption"]["ot"][$this->piVars['donation'][$donationkeys[$i]]['option']]["amount"];
					}
					$j++;
				}
				$substArray['###DONATIONS###'] .= '</div>';
			}
		}
		
		if ($substArray['###DONATIONS###']) {
			$substArray['###VERIFY_DONATIONS_MSG###'] = '  <div class="confirmation">'."\r".'      <div><em>'.$this->pi_getLL("verify_donations_msg").'</em></div>'; 
			$substArray['###DONATIONS###'] .= '</div>';
		}
		$substArray['###I_AGREE_MONEY_MSG###'] = '';
		if($this->money) $substArray['###I_AGREE_MONEY_MSG###'] = $this->getFFLLrelContent($element["country"][$this->piVars["country"]]["flexform"],"iagreemessage");
		$substArray['###checked###'] = '';
		if($this->piVars['button'][2] && !$this->error && $this->piVars['iagree']['terms']) $substArray['###checked###'] .= ' checked';
		$substArray['###I_AGREE_TERMS_MSG###'] = $this->getFFLLrelContent($element['membership'][$this->piVars["memLevelid"]]["flexform"],"iagreemessage");
		if($this->piVars['button'][2] && !$this->piVars['iagree']['terms']) $substArray['###I_AGREE_TERMS_MSG###'] = '<span class="error">'.$substArray['###I_AGREE_TERMS_MSG###'].'</span>';

		
		$substArray['###I_AGREE_BUTTON_NAME###'] = $this->pi_getLL("i_agree_button_name"); 
		$substArray['###I_AGREE_BELOW_BUTTON_MSG###'] = $this->pi_getLL("i_agree_below_button_msg"); 

		$out .= $this->cObj->substituteMarkerArrayCached($dataRowContent,$substArray);
		return $out;
	}
	/**
	 * [Put your description here]
	 */
	function membershipDues($element) {
		if($this->piVars['duesPayOption']['other'][$this->piVars["memLevelid"]][$this->piVars['duesPayOption'][$this->piVars["memLevelid"]]]) {
			$dues .=	$this->piVars['duesPayOption']['other'][$this->piVars["memLevelid"]][$this->piVars['duesPayOption'][$this->piVars["memLevelid"]]].' ';
			if($this->piVars["duesPaySchedule"] == 'MO') $dues .= $this->pi_getLL("payschedule_monthly");
			if($this->piVars["duesPaySchedule"] == 'OT') $dues .= $this->pi_getLL("payschedule_onetime");
		} else {
			$dues .=	$element['membership'] [$this->piVars["memLevelid"]] ["payoption"] [strtolower($this->piVars["duesPaySchedule"])] [$this->piVars['duesPayOption'][$this->piVars["memLevelid"]]] ["amount"].' ';
			$dues .= $this->getFFLLrelContent($element['membership'] [$this->piVars["memLevelid"]] ["payoption"] [strtolower($this->piVars["duesPaySchedule"])] [$this->piVars['duesPayOption'][$this->piVars["memLevelid"]]] ["flexform"],"label");
		}

		if(trim($dues)) {
			$dues = $element['membership'] [$this->piVars["memLevelid"]] ["currency"].$dues;
		} else {
				$dues = $this->getFFLLrelContent($element['membership'][$this->piVars["memLevelid"]]["flexform"],"teasertext"); 
		}
		return $dues;
	}

	/**
	 * [Put your description here]
	 */
	function composeExEmail($contactINFO) {
		$base = $this->email['external']['###COUNTRY_EMAIL###'];
		$this->email['external']['##DONATION_EMAIL##'] = '';
		for($i=0; $i<count($this->email['donation']); $i++) {
			$this->email['external']['##DONATION_EMAIL##'] .= "\r\n\r\n".$this->cObj->substituteMarkerArrayCached($this->email['donation'][$i]['external']['##DONATION_EMAIL##'],$this->email['donation'][$i]['global']);
		}
		$this->email['internal']['##PERSONAL_INFO##'] = $contactINFO['personal']['email']; 
		$this->email['internal']['##BILLING_INFO##'] = $contactINFO['billing']['email'];

		$out = $this->cObj->substituteMarkerArrayCached($base,$this->email['external']);
		$out = $this->cObj->substituteMarkerArrayCached($out,$this->email['global']);
		return $out;
	}
	/**
	 * [Put your description here]
	 */
	function composeInEmail($contactINFO) {
		$base = $this->email['internal']['###COUNTRY_EMAIL###'];
		$this->email['internal']['##DONATION_EMAIL##'] = '';
		for($i=0; $i<count($this->email['donation']); $i++) {
			$this->email['internal']['##DONATION_EMAIL##'] .= "\r\n\r\n".$this->cObj->substituteMarkerArrayCached($this->email['donation'][$i]['internal']['##DONATION_EMAIL##'],$this->email['donation'][$i]['global']);
		}
		$this->email['internal']['##PERSONAL_INFO##'] = $contactINFO['personal']['email']; 
		$this->email['internal']['##BILLING_INFO##'] = $contactINFO['billing']['email'];
		
		$out = $this->cObj->substituteMarkerArrayCached($base,$this->email['internal']);
		$out = $this->cObj->substituteMarkerArrayCached($out,$this->email['global']);
		return $out;
	}

	/**
	 * [Put your description here]
	 */
	function getFieldContent($fN)	{
		switch($fN) {	
			default:
				return $this->internal["currentRow"][$fN];
			break;
		}
	}
	/**
	 * Returns localized content from the field flexform for the current row
	 */
	function getFFLLContent($fN,$sN ='sDEF') {
		if (!is_array($this->internal["currentRow"]['flexform']) && $this->internal["currentRow"]['flexform'])    {
				$this->internal["currentRow"]['flexform'] = t3lib_div::xml2array($this->internal["currentRow"]['flexform']);
				if (!is_array($this->internal["currentRow"]['flexform']))        $this->internal["currentRow"]['flexform']=array();
		}
		$localContent = $this->pi_getFFvalue($this->internal["currentRow"]['flexform'], $fN, $sN, $this->FFLLkey);
		if(!$localContent && $this->FFLLkey != 'lDEF') $localContent = $this->pi_getFFvalue($this->internal["currentRow"]['flexform'], $fN, $sN, 'lDEF');
		return $localContent;
	}
	/**
	 * [Put your description here]
	 */
	function getFFLLrelContent($flexform,$fN,$sN='sDEF') {
		if (!is_array($flexform) && $flexform)    {
				$flexform = t3lib_div::xml2array($flexform);
				if (!is_array($flexform)) $flexform = array();
		}
		$localContent = $this->pi_getFFvalue($flexform, $fN, $sN, $this->FFLLkey);
		if(!$localContent && $this->FFLLkey != 'lDEF') $localContent = $this->pi_getFFvalue($flexform, $fN, $sN, 'lDEF');
		return $localContent;
	}	
	/**
	 * [Put your description here] 
	 */
	function flexform_ds2html($flexform_ds,$sheet='sDEF',$validate=0)	{
		# convert FF to ARRAY
		$ff_array = t3lib_div::xml2array($flexform_ds);
		# get Fieldnames / Keys
		if(is_array($ff_array)) {
			# get list of fields
			$fieldname = array_keys($ff_array['sheets'][$sheet]['ROOT']['el']);
			# loop to generate elements
			for($i=0; $i<count($fieldname); $i++) {
			$label = $this->flexform_ds_getLL($ff_array['sheets'][$sheet]['ROOT']['el'][$fieldname[$i]]['TCEforms']['label']);
				switch($ff_array['sheets'][$sheet]['ROOT']['el'][$fieldname[$i]]['TCEforms']['config']['type']) {
					case "select":
							$out['form'] .= "     <tr>\r          <td class='table-row".($i%2 ? 2 : 1)."' width='1'>".$label['label'].'</td>'."\r";
							$out['form'] .= "         <td class='table-row".($i%2 ? 2 : 1)."'>\r".'               <select name="tx_acornmember_pi1['.$sheet.']['.$fieldname[$i].']">'."\r";
							for ($j=0; $j<count($ff_array['sheets'][$sheet]['ROOT']['el'][$fieldname[$i]]['TCEforms']['config']['items']); $j++) {
								$out['form'] .= '                    <option value="'.$ff_array['sheets'][$sheet]['ROOT']['el'][$fieldname[$i]]['TCEforms']['config']['items'][$j][1].'"';
								$label = $this->flexform_ds_getLL($ff_array['sheets'][$sheet]['ROOT']['el'][$fieldname[$i]]['TCEforms']['config']['items'][$j][0]);
								if(trim($this->piVars[$sheet][$fieldname[$i]]) && $this->piVars[$sheet][$fieldname[$i]] == $ff_array['sheets'][$sheet]['ROOT']['el'][$fieldname[$i]]['TCEforms']['config']['items'][$j][1]) {
									$out['form'] .= ' selected';
									$out['plain'] .= $label['label']."<br>\r";
									$out['email'] .= $label['label']."\n\r";
								}
								$out['form'] .= '>'.$label['label']."</option>\r";
							}
							$out['form'] .= "               </select>\r";
							if ($validate && $label['required'] && !$this->piVars[$sheet][$fieldname[$i]]) {
								$out['form'] .= '<span class="error"> '.$this->pi_getLL("required_error2").'</span>';
								$this->error++;
							}
							 $out['form'] .= "         </td>\r     </tr>\r";
						break;

					default: // input
							$out['form'] .= "     <tr>\r          <td class='table-row".($i%2 ? 2 : 1)."' width='1'>".$label['label'].'</td>'."\r";
							$out['form'] .= "         <td class='table-row".($i%2 ? 2 : 1)."'>".'<input type="text" name="tx_acornmember_pi1['.$sheet.']['.$fieldname[$i].']"';
							if (trim($this->piVars[$sheet][$fieldname[$i]])) {
								$out['form'] .= ' value="'.$this->piVars[$sheet][$fieldname[$i]].'"';
								$out['plain'] .= $this->piVars[$sheet][$fieldname[$i]]."<br>\r";
								$out['email'] .= $this->piVars[$sheet][$fieldname[$i]]."\n\r";
							}
							$out['form'] .= ' size="'.$ff_array['sheets'][$sheet]['ROOT']['el'][$fieldname[$i]]['TCEforms']['config']['size'].'">';
							if ($validate && $label['required'] && !trim($this->piVars[$sheet][$fieldname[$i]]) ) {
								$out['form'] .= '<span class="error"> '.$this->pi_getLL("required_error").'</span>';
								$this->error++;
							}
							$out['form'] .= '</td>'."\r     </tr>";
						break;
				}
			}
			$out['form'] = '<table width="95%">'.$out['form'].'</table>';
			$out['plain'] = substr($out['plain'], 0, -5); 
			# $out['email'] = substr($out['email'], 0, -3); 
		}
		return $out;
	}
	/**
	 * [Put your description here]
	 */
	function flexform_ds_getLL($pointer)	{
		# split the line on :
		$part = explode ( ':', $pointer);
		if (!$part[3]) {
			$out['label'] = $pointer;
		}  else {
			# gett LL file and cache if not already called
			if (!$this->flexform_ds_LL[$part[2]]) $this->flexform_ds_LL[$part[2]] = tslib_fe::readLLfile($part[1].':'.$part[2]);
			$label = $this->flexform_ds_LL[$part[2]][$this->LLkey][$part[3]];
			# look for required fields
			if ($this->conf['requiredSymbol'] = '*')  {
				if (ereg('\\'.$this->conf['requiredSymbol'], $label)) $out['required'] = 1;
			} else {
				if (ereg($this->conf['requiredSymbol'], $label)) $out['required'] = 1;
			}
			# wrap required field indicator
			$out['label'] = str_replace ($this->conf["requiredSymbol"], $this->requiredSymbolWrap[0].$this->conf["requiredSymbol"].$this->requiredSymbolWrap[1], $label);
		}
		return $out;
	}	
}
if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/acorn_member/pi1/class.tx_acornmember_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/acorn_member/pi1/class.tx_acornmember_pi1.php"]);
}
?>